function createPluginsOrBehaviorsForm(data, behaviorIndex) {
	var paramInfoList = new Array();// ParamInfoModel
	var fieldHTML = "";
	for (var i = 0; i < data.length; i++) {
		paramInfoList.push(data[i]);
	}
	var nfieldCount = 0;
	for (var j = 0; j < paramInfoList.length; j++) {
		var paramTypeModel = paramInfoList[j].paramTypeModel;
		var methodParamModel = new ParamInfoModel(paramInfoList[j].name,
				paramInfoList[j].label, paramTypeModel);
		var type = paramTypeModel.type;
		if (type == "field") {
			var size = paramTypeModel.size;
			var text = paramTypeModel.text;
			fieldHTML += createField(methodParamModel.label,
					methodParamModel.name, size, text, behaviorIndex);
		} else if (type == "nfield") {
			var size = paramTypeModel.size;
			var text = paramTypeModel.text;
			fieldHTML += createMultiField(methodParamModel.label,
					methodParamModel.name, size, text, nfieldCount);
			nfieldCount++;
		} else if (type == "table") {
			var cols = paramTypeModel.cols;
			fieldHTML += createTable(methodParamModel.label,
					methodParamModel.name, cols, null, behaviorIndex);
		} else if (type == "checkBox") {
			var rows = paramTypeModel.choiceModels;
			fieldHTML += createCheckBox(methodParamModel.label,
					methodParamModel.name, rows, null, behaviorIndex);
		} else if (type == "radioButton") {
			var rows = paramTypeModel.choiceModels;// List<ChoiceModel>
			fieldHTML += createRadioButton(methodParamModel.label,
					methodParamModel.name, rows, null, behaviorIndex);
		} else if (type == "file") {
			var text = paramTypeModel.text;
			fieldHTML += createFile(methodParamModel.label,
					methodParamModel.name, text, behaviorIndex);
		}
	}
	return fieldHTML;
}

function createFile(label, name, text, behaviorIndex) {
	var divNode=document.createElement("div");
	var p=document.createElement("p");
	var labelNode = document.createTextNode(label);
	var div = document.createElement("div");
	var nameNode = document.createTextNode(name);
	var input=$(document.createElement("input"));
	$(divNode).attr("class", "File sample_frame");
	$(divNode).attr("id", behaviorIndex + "_" + name);
	$(div).attr("class", "sample_sub_frame");
	input.attr("type","file");
	input.attr("id","file"+behaviorIndex);
	p.appendChild(labelNode);
	div.appendChild(nameNode);
	$(div).append(input);
	divNode.appendChild(p);
	divNode.appendChild(div);
	return divNode.outerHTML;
}

function createField(label, name, size, text, behaviorIndex) {
	if (size == 0) {
		size = 10;
	}
	var divNode = document.createElement("div");
	var p = document.createElement("p");
	var labelNode = document.createTextNode(label);
	var div = document.createElement("div");
	var nameNode = document.createTextNode(name);
	var input = document.createElement("input");

	$(divNode).attr("class", "Field sample_frame");
	$(divNode).attr("id", behaviorIndex + "_" + name);
	$(div).attr("class", "sample_sub_frame");
	$(input).attr("type", "text");
	$(input).attr("size", size);
	$(input).attr("id", name + "_input");
	if (text != null) {
		$(input).attr("value", text);
	}
	p.appendChild(labelNode);
	div.appendChild(nameNode);
	div.appendChild(input);
	divNode.appendChild(p);
	divNode.appendChild(div);
	return divNode.outerHTML;
}

function createMultiField(label, name, size, text, behaviorIndex) {
	if (size == 0) {
		size = 10;
	}

	var divNode = document.createElement("div");
	var p = document.createElement("p");
	var labelNode = document.createTextNode(name + ":" + label);
	var div = document.createElement("div");
	var addFieldButton = document.createElement("button");
	var addFieldNode = document.createTextNode($.i18n.prop("addField"));
	var removeFieldButton = document.createElement("button");
	var removeFieldNode = document.createTextNode($.i18n.prop("removeField"));
	var br = document.createElement("br");
	var table = document.createElement("table");

	$(divNode).attr("class", "NField sample_frame");
	$(divNode).attr("id", behaviorIndex + "_" + name);
	$(div).attr("class", "sample_sub_frame");
	$(addFieldButton).attr("type", "submit");
	$(addFieldButton).attr("class", "btn-large");
	$(addFieldButton).attr("onClick",
			"addField(" + size + "," + behaviorIndex + "," + null + ");");
	$(removeFieldButton).attr("type", "submit");
	$(removeFieldButton).attr("class", "btn-large");
	$(removeFieldButton).attr("onClick", "removeField(this)");
	$(table).attr("id", "addFieldTable_" + behaviorIndex);
	$(table).attr("class", "table-margin");
	if (text != null) {
		var content = text.split(";");
		for (var i = 0; i < content.length; i++) {
			createAFieldLine(10, i, behaviorIndex, content[i]);
		}
	}
	p.appendChild(labelNode);
	addFieldButton.appendChild(addFieldNode);
	removeFieldButton.appendChild(removeFieldNode);
	div.appendChild(addFieldButton);
	div.appendChild(removeFieldButton);
	div.appendChild(br);
	div.appendChild(table);
	divNode.appendChild(p);
	divNode.appendChild(div);
	return divNode.outerHTML;
}

function getFieldCount(addId) {
	return $("#addFieldTable_" + addId).children().length;
}

function createAFieldLine(size, field, addId, value) {
	var data = "field_" + field + ":";
	var newTrNode = document.createElement("tr");
	var newTdNode1 = document.createElement("td");
	var newTdNode2 = document.createElement("td");
	newTdNode1.setAttribute("class", data);
	var textNode = document.createTextNode(data);
	var inputNode = document.createElement("input");
	inputNode.setAttribute("type", "text");
	inputNode.setAttribute("size", size);
	if (value != null) {
		inputNode.setAttribute("value", value);
	}
	newTdNode1.appendChild(textNode);
	newTdNode2.appendChild(inputNode);
	newTrNode.appendChild(newTdNode1);
	newTrNode.appendChild(newTdNode2);
	return newTrNode;
}

function addField(size, addId, value) {
	var field = getFieldCount(addId);
	var newTrNode = createAFieldLine(size, field, addId, value);
	document.getElementById("addFieldTable_" + addId).appendChild(newTrNode);
}

function removeField(selectedNode) {
	var table = selectedNode.nextSibling.nextSibling;
	var deletedNode = table.lastChild;
	table.removeChild(deletedNode);
}

function createTable(label, name, cols, value, behaviorIndex) {
	var table_content = cols.split(";");// table分隔符
	var col = table_content.length;
	var tableWidth = 300 / col;
	var tr = document.createElement("tr");
	for (var i = 0; i < col; i++) {
		var th = document.createElement("th");
		var text = document.createTextNode(table_content[i]);
		th.appendChild(text);
		tr.appendChild(th);
	}
	var divNode = document.createElement("div");
	var p = document.createElement("p");
	var labelNode = document.createTextNode(label);
	var div = document.createElement("div");
	var nameNode = document.createTextNode(name);
	var br1 = document.createElement("br");
	var br2 = document.createElement("br");
	var addColButton = document.createElement("button");
	var addColNode = document.createTextNode($.i18n.prop("addCol"));
	var removeColButton = document.createElement("button");
	var removeColNode = document.createTextNode($.i18n.prop("removeCol"));
	var table = document.createElement("table");
	var thead = document.createElement("thead");
	var tbody = document.createElement("tbody");

	if (value != null) {
		value = value.split("|;");// 一行的信息
		var row = value.length - 1;
		for (var m = 0; m < row; m++) {
			var colValue = value[m].split("|");// 一行中的每列信息
			var trNode = document.createElement("tr");
			for (var n = 0; n < col; n++) {
				var tdNode = document.createElement("td");
				var input = document.createElement("input");
				input.setAttribute("size", 10);
				input.setAttribute("type", "text");
				input.setAttribute("style", "width:" + tableWidth + "px;");
				input.setAttribute("value", colValue[n]);
				tdNode.appendChild(input);
				trNode.appendChild(tdNode);
			}
			tbody.appendChild(trNode);
		}
	}

	$(divNode).attr("class", "Table sample_frame");
	$(divNode).attr("id", behaviorIndex + "_" + name);
	$(div).attr("class", "sample_sub_frame");
	$(addColButton).attr("type", "submit");
	$(addColButton).attr("class", "btn-large");
	$(addColButton).attr("onClick", "addCol(this)");
	$(addColButton).attr("id", tableWidth);
	$(removeColButton).attr("type", "submit");
	$(removeColButton).attr("class", "btn-large");
	$(removeColButton).attr("onClick", "removeCol(this)");
	$(table).attr("class", behaviorIndex + "_operateTableCols");
	$(table).attr("class", "table-margin");

	p.appendChild(labelNode);
	addColButton.appendChild(addColNode);
	removeColButton.appendChild(removeColNode);
	thead.appendChild(tr);
	table.appendChild(thead);
	table.appendChild(tbody);
	div.appendChild(nameNode);
	div.appendChild(br1);
	div.appendChild(addColButton);
	div.appendChild(removeColButton);
	div.appendChild(br2);
	div.appendChild(table);
	divNode.appendChild(p);
	divNode.appendChild(div);
	return divNode.outerHTML;

}

function addCol(selectedNode) {
	var tableWidth = $(selectedNode).attr("id");
	var tbody = selectedNode.nextSibling.nextSibling.nextSibling.lastChild;
	var length = tbody.previousSibling.firstChild.childNodes.length;
	var tr = document.createElement("tr");
	for (var i = 0; i < length; i++) {
		var td = document.createElement("td");
		var input = document.createElement("input");
		input.setAttribute("size", 10);
		input.setAttribute("type", "text");
		input.setAttribute("style", "width:" + tableWidth + "px;");
		td.appendChild(input);
		tr.appendChild(td);
	}
	tbody.appendChild(tr);
}

function removeCol(selectedNode) {
	var tbody = selectedNode.nextSibling.nextSibling.lastChild;
	var removeNode = tbody.lastChild;
	tbody.removeChild(removeNode);
}

function createCheckBox(label, name, rows, value, behaviorIndex) {
	var valueList = new Array();
	var defaultList = new Array();
	
	for (var j = 0; j < rows.length; j++) {
		valueList.push(rows[j].value);
		defaultList.push(rows[j].defaultValue);
	}
	
	if (value != null) {
		value = value.split(";");
		for (var m = 0; m < value.length; m++) {
			for (var n = 0; n < rows.length; n++) {
				if (valueList[n] == value[m]) {
					defaultList[n] = true;
					break;
				}
			}
		}
	}
	
	var divNode = document.createElement("div");
	var p = document.createElement("p");
	var div = document.createElement("div");
	var br = document.createElement("br");
	var divInput = document.createElement("div");
	var labelNode = document.createTextNode(label);
	var nameNode = document.createTextNode(name);
	$(divNode).attr("class", "CheckBox sample_frame");
	$(divNode).attr("id", "checkbox_" + name + "_" + behaviorIndex);
	$(div).attr("class", "sample_sub_frame");
	$(divInput).attr("class", "sample_sub_frame");
	p.appendChild(labelNode);

	for (var i = 0; i < rows.length; i++) {
		var checkBoxNode = document.createElement("input");
		var brInput = document.createElement("br");
		checkBoxNode.setAttribute("type", "checkbox");
		checkBoxNode.setAttribute("name", "checkbox");
		checkBoxNode.setAttribute("value", valueList[i]);
		if (defaultList[i] == true) {
			checkBoxNode.setAttribute("checked", "checked");
		}
		var checkBoxValue = document.createTextNode(valueList[i]);
		divInput.appendChild(checkBoxNode);
		divInput.appendChild(checkBoxValue);
		divInput.appendChild(brInput);
	}
	div.appendChild(nameNode);
	div.appendChild(br);
	div.appendChild(divInput);
	divNode.appendChild(p);
	divNode.appendChild(div);
	return divNode.outerHTML;

}

function createRadioButton(label, name, rows, value, behaviorIndex) {
	var valueList = new Array();
	var defaultList = new Array();
	for (var i = 0; i < rows.length; i++) {
		var choiceModel = rows[i];
		valueList.push(choiceModel.value);
		defaultList.push(choiceModel.defaultValue);
	}
	if(value!=null){
		for(var m=0;m<rows.length;m++){
			if(valueList[m]==value){
				defaultList[m]=true;
				break;
			}
		}
	}
	var divNode = document.createElement("div");
	var p = document.createElement("p");
	var div = document.createElement("div");
	var br = document.createElement("br");
	var divInput = document.createElement("div");
	var labelNode = document.createTextNode(label);
	var nameNode = document.createTextNode(name);
	$(divNode).attr("class", "RadioButton sample_frame");
	$(divNode).attr("id", "radio_" + name + "_" + behaviorIndex);
	$(div).attr("class", "sample_sub_frame");
	$(divInput).attr("class", "sample_sub_frame");
	p.appendChild(labelNode);
	for (var i = 0; i < valueList.length; i++) {
		var checkBoxNode = document.createElement("input");
		var brInput = document.createElement("br");
		checkBoxNode.setAttribute("type", "radio");
		checkBoxNode.setAttribute("name", "radio");
		checkBoxNode.setAttribute("value", valueList[i]);
		if (defaultValue[i] == true) {
			checkBoxNode.setAttribute("checked", "checked");
		}
		var checkBoxValue = document.createTextNode(valueList[i]);
		divInput.appendChild(checkBoxNode);
		divInput.appendChild(checkBoxValue);
		divInput.appendChild(brInput);
	}
	div.appendChild(nameNode);
	div.appendChild(br);
	div.appendChild(divInput);
	divNode.appendChild(p);
	divNode.appendChild(div);
	return divNode.outerHTML;
}