var Parameter = function(key, value) {
	this.key = key;
	this.value = value;
}
var DataCollector = function() {
};
DataCollector.prototype.fieldData = function(editor) {
	editor = $(editor.children('.field'));
	var name = editor.children("label").html();
	var value = editor.children("input").val();
	if (value == null || value == "") {
		information("please input data in " + editor.attr("id"));
		return;
	}

	return new Parameter(name, value);
};
DataCollector.prototype.dateData = function(editor) {
	var name = editor.children("label").html();
	var value = editor.children("input").val();
	if (value == null || value == "") {
		information("please input data in " + editor.attr("id"));
		return;
	}

	return new Parameter(name, value);
};
DataCollector.prototype.multiFieldData = function(editor) {
	var editorArray = editor.children(".field");
	if (ediotrArray.size == 0) {
		information("please input data in " + editor.attr("id"));
		return;

	}
	var name = editor.attr("id")
	var value = "";

	for ( var i = 0; i < editorArray.length; i++) {
		var filedValue = $(editorArray[i]).children("input").val();
		if (filedValue == null || filedValue == "") {
			information("please input data in" + editor.attr("id"));
			return;
		}

		value += fieldVlaue + ";";
	}
	value = value.substring(0, value.length - 1);
	return new Parameter(name, value);

};

DataCollector.prototype.tableData = function(editor) {
	var editorArray = editor.find("tbody").children("tr");
	var name = editor.attr("id");
	var value = "";
	for ( var i = 0; i < editorArray.length; i++) {
		var tdArray = $(editorArray[i]).children("td");
		var trValue = "";
		for ( var j = 1; j < tdArray.length; j++) {
			trValue += $(tdArray[j]).children("input").val() + "|";
		}
		trValue = trValue.substring(0, trValue.length - 1);
		value += trValue + ";";
	}
	value = value.substring(0, value.length - 1);
	return new Parameter(name, value);

};
DataCollector.prototype.selectData = function(editor) {
	var name = editor.attr("id");
	var value = editor.children("select").val();
	return new Parameter(name, value);
};

DataCollector.prototype.getUnitParams = function(paramEditors) {
	var params = new Array();
	for ( var i = 0; i < paramEditors.length; i++) {
		var editor = $(paramEditors[i]);
		var editorType = editor.attr("editorType");
		if (editorType == "field") {
			params.push(this.fieldData(editor));
		} else if (editorType == "date") {
			params.push(this.dateData(editor));
		} else if (editorType == "multiField") {
			params.push(this.multiFieldData(deditor));
		} else if (editorType == "table") {
			params.push(this.tableData(editor));
		} else if (editorType == "select") {
			params.push(this.selectData(editor));
		}
	}
	return params;
};

var BehaviorData = function(name, usePlugin, type, parameters) {
	this.name = name;
	this.type = type;
	this.use = usePlugin;
	this.parameters = parameters;
};
function getBehaviorNames(usePlugins) {
	var behaviorNames = new Array();
	var behaviorName = "Send";
	for ( var i = 0; i < usePlugins.length; i++) {
		behaviorNames.push(usePlugins[i].id + "_" + behaviorName);

	}
	return behaviorNames;

};

function getBehaviorDatas(behaviorNames) {
	var behaviors = new Array();
	var behaviorEditor = $("#behaviors").children(".containerBox");
	var type = "USERBEHAVIOR";
	for ( var i = 0; i < behaviorNames.length; i++) {
		behaviors.push(getBehaviorData(behaviorEditor, behaviorNames[i], type));
	}
	return behaviors;
	function getBehaviorData(editor, behaviorName, type) {
		var paramEditors = editor.find(".editor");
		var names = behaviorName.split("_");
		var usePlugin = names[0];
		var behavior = names[1];
		var dataCollector = new DataCollector();
		var params = dataCollector.getUnitParams(paramEditors);
		var behavior = new BehaviorData(behavior, usePlugin, type, params);
		return behavior;
	}
	;

};
var PluginData = function(id, name, params) {

	this.id = id;
	this.name = name;
	this.parameters = params;
}

function getPluginDatas() {
	var pluginContainers = $("#devices").children(".containerBox");
	var separators = $("#devices").children(".separator");
	var plugins = new Array();
	var pluginCount = -1;
	var pluginName = "hbase";
	for ( var i = 0; i < pluginContainers.length; i++) {
		var deviceSize = $(separators[i]).children("input").val();
		if (deviceSize == null || deviceSize == "") {
			information("no device config");
			return [];
		}
		var dataCollector = new DataCollector();
		var params = dataCollector.getUnitParams($(pluginContainers[i]).find(".editor"));
		for ( var j = 1; j <= deviceSize; j++) {
			pluginCount++;
			var id=pluginName+pluginCount;
			plugins.push(new PluginData(id, pluginName,params));
		}

	}
	return plugins;


}
