var DeviceFactory = function(deviceEditorInfo, container, behaviorEditorInfo) {
	this.deviceEditorInfo = deviceEditorInfo;
	this.container = container;
	this.behaviorEditorInfo = behaviorEditorInfo;
};
DeviceFactory.prototype.createDevice = function(header, id) {

	var deviceSizeConfig = this.createDeviceSizeConfig();
	var containerFactory = new ContainerFactory();
	var deviceContainer = containerFactory.createEditorContainer(header, id,
			this.deviceEditorInfo);
	var behaviorFactory = new BehaviorFactory(this.container);
	behaviorFactory.createBehavior("Device Data Sender", "behavior",
			this.behaviorEditorInfo);
	
	this.container.prepend(deviceContainer);
	this.container.prepend(deviceSizeConfig);

};
DeviceFactory.prototype.createDeviceSizeConfig = function() {
	var deviceSizeConfig = document.createElement("div");
	$(deviceSizeConfig).addClass("separator");
	var label = document.createElement("label");
	$(label).html("Device Size:");
	var input = document.createElement("input");
	$(input).attr("type", "text");
	$(deviceSizeConfig).append(label);
	$(deviceSizeConfig).append(input);
	return deviceSizeConfig;
}

var BehaviorFactory = function(container) {
	this.container = container;

};
BehaviorFactory.prototype.createBehavior = function(header, id, editorInfo) {
	var title = this.createTitle();
	var containerFactory = new ContainerFactory();
	var editorContainer = containerFactory.createEditorContainer(header, id,
			editorInfo);

	this.container.prepend(editorContainer)
		this.container.prepend(title);
};
BehaviorFactory.prototype.createTitle = function() {
	var title = document.createElement("div");
	$(title).addClass("separator");
	$(title).attr("style", "color:#4183c4")
	$(title).html("Configure Device Data Sender")
	return title;
}
